#version 330 core

uniform samplerCube cubemap_tex;
uniform vec4 WS_pos_light;
uniform vec2 near_far; 

in vec4 WS_pos; 

out vec4 FragColor;

void main(void) {
	float ne = near_far.x;
	float fa = near_far.y;
	// Calculate vector from surface point to light position:
	vec3 cm_lookup_vec = WS_pos.xyz - WS_pos_light.xyz;
	// Read depth value from cubemap shadow map:
	float d_L = texture(cubemap_tex, cm_lookup_vec).r;
	// Distance between light and fragment:
	float d_S = length(cm_lookup_vec);
	// Undo previous [0;1]-mapping. Transform to world space [near,far]:
	d_L = d_L * (fa - ne) + ne;
	// Add a small offset to prevent shadow-acne (Adjust for your scene!)
	const float eps = 0.1;

	//FragColor = vec4(d_L, d_L, d_L, 1.0f);
	//FragColor = vec4(d_S/near_far.y, d_S/near_far.y, d_S/near_far.y, 1.0f); 

	if (d_L + eps < d_S) {
		FragColor = vec4(0.4f, 0.4f, 0.4f, 1.0f); 
		//FragColor = vec4(WS_pos.x, WS_pos.y, WS_pos.z, 1.0f); 
		//FragColor = vec4(d_S/fa, d_S/near_far.y, d_S/near_far.y, 1.0f); 
	}
	else {
		FragColor = vec4(0.8f, 0.8f, 0.8f, 1.0f);
		//FragColor = vec4(d_S/near_far.y, d_S/near_far.y, d_S/near_far.y, 1.0f); 
	}

	// ==> Fragment lies in shadow
	// Perform other calculations, then set fragments color
}

