#version 330 core

uniform vec2 near_far; // near and far plane of the light cams
uniform vec4 l_pos; // world space light position

in vec4 WS_pos_from_GS; // vertex from geometry shader

//layout(location=0) out vec4 outColor;

void main() {
	// calculate distance
	float WS_dist = distance(WS_pos_from_GS, l_pos);
	// map value to [0;1] by taking near/far plane into account
	float ne = near_far.x;
	float fa = near_far.y;
	float diff = fa - ne;
	float WS_dist_normalized = (WS_dist - ne) / (fa - ne);
	//float WS_dist_normalized = (WS_dist) / (fa);
	// write modified depth
	gl_FragDepth = WS_dist_normalized;
	//outColor = vec4(1.0f, 1.0f, 0.0f, 1.0);
	// when using depth-only FBO, do NOT write to color!!!
}